blob: 71cb1c6820b10abb5fd8bc232aa160ac570a77db [file] [log] [blame]
Colin Cross665dce92016-04-28 14:50:03 -07001#!/bin/bash -e
2
Colin Crossd00350c2017-11-17 10:55:38 -08003# Copyright 2017 Google Inc. All rights reserved.
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
Colin Cross665dce92016-04-28 14:50:03 -070017# Script to handle the various ways soong may need to strip binaries
18# Inputs:
19# Environment:
Chih-Hung Hsieh30485c92018-06-04 10:37:43 -070020# CLANG_BIN: path to the clang bin directory
Dan Willemsen8fec83a2018-03-09 10:47:52 -080021# XZ: path to the xz binary
Colin Cross665dce92016-04-28 14:50:03 -070022# Arguments:
Colin Cross26c34ed2016-09-30 17:10:16 -070023# -i ${file}: input file (required)
Colin Cross665dce92016-04-28 14:50:03 -070024# -o ${file}: output file (required)
25# -d ${file}: deps file (required)
Yi Kongacee27c2019-03-29 20:05:14 -070026# -k symbols: Symbols to keep (optional)
Colin Cross665dce92016-04-28 14:50:03 -070027# --add-gnu-debuglink
Chih-Hung Hsieh30485c92018-06-04 10:37:43 -070028# --keep-mini-debug-info
29# --keep-symbols
Christopher Ferrisb43fe7a2019-05-17 16:39:54 -070030# --keep-symbols-and-debug-frame
Vic Yangefd249e2018-11-12 20:19:56 -080031# --remove-build-id
Colin Cross665dce92016-04-28 14:50:03 -070032
Colin Cross8e877af2018-09-19 15:09:26 -070033set -o pipefail
34
Yi Kongacee27c2019-03-29 20:05:14 -070035OPTSTRING=d:i:o:k:-:
Colin Cross665dce92016-04-28 14:50:03 -070036
37usage() {
38 cat <<EOF
Yi Kongacee27c2019-03-29 20:05:14 -070039Usage: strip.sh [options] -k symbols -i in-file -o out-file -d deps-file
Colin Cross665dce92016-04-28 14:50:03 -070040Options:
Christopher Ferrisb43fe7a2019-05-17 16:39:54 -070041 --add-gnu-debuglink Add a gnu-debuglink section to out-file
42 --keep-mini-debug-info Keep compressed debug info in out-file
43 --keep-symbols Keep symbols in out-file
44 --keep-symbols-and-debug-frame Keep symbols and .debug_frame in out-file
Christopher Ferrisb43fe7a2019-05-17 16:39:54 -070045 --remove-build-id Remove the gnu build-id section in out-file
Colin Cross665dce92016-04-28 14:50:03 -070046EOF
47 exit 1
48}
49
50do_strip() {
Yi Kongab5e5142019-09-12 21:24:12 -070051 # GNU strip --strip-all does not strip .ARM.attributes,
Chih-Hung Hsieh30485c92018-06-04 10:37:43 -070052 # so we tell llvm-strip to keep it too.
Yi Kongab5e5142019-09-12 21:24:12 -070053 "${CLANG_BIN}/llvm-strip" --strip-all --keep-section=.ARM.attributes "${infile}" -o "${outfile}.tmp"
Colin Cross665dce92016-04-28 14:50:03 -070054}
55
Christopher Ferrisb43fe7a2019-05-17 16:39:54 -070056do_strip_keep_symbols_and_debug_frame() {
Yi Kongab5e5142019-09-12 21:24:12 -070057 REMOVE_SECTIONS=`"${CLANG_BIN}/llvm-readelf" -S "${infile}" | awk '/.debug_/ {if ($2 != ".debug_frame") {print "--remove-section " $2}}' | xargs`
58 "${CLANG_BIN}/llvm-objcopy" "${infile}" "${outfile}.tmp" ${REMOVE_SECTIONS}
Christopher Ferrisb43fe7a2019-05-17 16:39:54 -070059}
60
Colin Cross665dce92016-04-28 14:50:03 -070061do_strip_keep_symbols() {
Yi Kongab5e5142019-09-12 21:24:12 -070062 REMOVE_SECTIONS=`"${CLANG_BIN}/llvm-readelf" -S "${infile}" | awk '/.debug_/ {print "--remove-section " $2}' | xargs`
63 "${CLANG_BIN}/llvm-objcopy" "${infile}" "${outfile}.tmp" ${REMOVE_SECTIONS}
Colin Cross665dce92016-04-28 14:50:03 -070064}
65
Yi Kongacee27c2019-03-29 20:05:14 -070066do_strip_keep_symbol_list() {
Yi Kongacee27c2019-03-29 20:05:14 -070067 echo "${symbols_to_keep}" | tr ',' '\n' > "${outfile}.symbolList"
Yi Kongacee27c2019-03-29 20:05:14 -070068
Yi Kong049ae6a2019-10-15 16:35:51 -070069 KEEP_SYMBOLS="--strip-unneeded-symbol=* --keep-symbols="
Yi Kongab5e5142019-09-12 21:24:12 -070070 KEEP_SYMBOLS+="${outfile}.symbolList"
David Srbecky789fe0f2021-04-08 16:52:05 +010071 "${CLANG_BIN}/llvm-objcopy" -w "${infile}" "${outfile}.tmp" ${KEEP_SYMBOLS}
Yi Kongacee27c2019-03-29 20:05:14 -070072}
73
David Srbecky69315e42021-04-29 21:06:47 +010074do_strip_keep_mini_debug_info_darwin() {
Colin Cross1b594092017-04-13 16:19:00 -070075 rm -f "${outfile}.dynsyms" "${outfile}.funcsyms" "${outfile}.keep_symbols" "${outfile}.debug" "${outfile}.mini_debuginfo" "${outfile}.mini_debuginfo.xz"
Colin Cross02b04bb2018-09-05 13:14:09 -070076 local fail=
Yi Kongab5e5142019-09-12 21:24:12 -070077 "${CLANG_BIN}/llvm-strip" --strip-all --keep-section=.ARM.attributes --remove-section=.comment "${infile}" -o "${outfile}.tmp" || fail=true
78
Colin Cross02b04bb2018-09-05 13:14:09 -070079 if [ -z $fail ]; then
David Srbecky789fe0f2021-04-08 16:52:05 +010080 "${CLANG_BIN}/llvm-objcopy" --only-keep-debug "${infile}" "${outfile}.debug"
Yi Kongeb63f762019-09-14 01:39:53 -070081 "${CLANG_BIN}/llvm-nm" -D "${infile}" --format=posix --defined-only 2> /dev/null | awk '{ print $1 }' | sort >"${outfile}.dynsyms"
82 "${CLANG_BIN}/llvm-nm" "${infile}" --format=posix --defined-only | awk '{ if ($2 == "T" || $2 == "t" || $2 == "D") print $1 }' | sort > "${outfile}.funcsyms"
Colin Cross1b594092017-04-13 16:19:00 -070083 comm -13 "${outfile}.dynsyms" "${outfile}.funcsyms" > "${outfile}.keep_symbols"
Ryan Prichardafefacf2018-03-27 22:15:45 -070084 echo >> "${outfile}.keep_symbols" # Ensure that the keep_symbols file is not empty.
David Srbecky789fe0f2021-04-08 16:52:05 +010085 "${CLANG_BIN}/llvm-objcopy" -S --keep-section .debug_frame --keep-symbols="${outfile}.keep_symbols" "${outfile}.debug" "${outfile}.mini_debuginfo"
86 "${XZ}" --keep --block-size=64k --threads=0 "${outfile}.mini_debuginfo"
Yi Kongab5e5142019-09-12 21:24:12 -070087
88 "${CLANG_BIN}/llvm-objcopy" --add-section .gnu_debugdata="${outfile}.mini_debuginfo.xz" "${outfile}.tmp"
Colin Cross3adb2ed2018-10-18 11:05:56 -070089 rm -f "${outfile}.dynsyms" "${outfile}.funcsyms" "${outfile}.keep_symbols" "${outfile}.debug" "${outfile}.mini_debuginfo" "${outfile}.mini_debuginfo.xz"
Colin Cross1b594092017-04-13 16:19:00 -070090 else
91 cp -f "${infile}" "${outfile}.tmp"
92 fi
Colin Cross665dce92016-04-28 14:50:03 -070093}
94
David Srbecky69315e42021-04-29 21:06:47 +010095do_strip_keep_mini_debug_info_linux() {
96 rm -f "${outfile}.mini_debuginfo.xz"
97 local fail=
98 "${CLANG_BIN}/llvm-strip" --strip-all --keep-section=.ARM.attributes --remove-section=.comment "${infile}" -o "${outfile}.tmp" || fail=true
99
100 if [ -z $fail ]; then
Eric Rahmeba99f42023-10-17 18:47:24 +0000101 # create_minidebuginfo has issues with compressed debug sections. Just
102 # decompress them for now using objcopy which understands compressed
103 # debug sections.
104 # b/306150780 tracks supporting this directly in create_minidebuginfo
105 decompressed="$(mktemp)"
106 "${CLANG_BIN}/llvm-objcopy" --decompress-debug-sections \
107 "${infile}" "${decompressed}"
108
109 "${CREATE_MINIDEBUGINFO}" "${decompressed}" "${outfile}.mini_debuginfo.xz"
David Srbecky69315e42021-04-29 21:06:47 +0100110 "${CLANG_BIN}/llvm-objcopy" --add-section .gnu_debugdata="${outfile}.mini_debuginfo.xz" "${outfile}.tmp"
Eric Rahmeba99f42023-10-17 18:47:24 +0000111 rm -f "${outfile}.mini_debuginfo.xz" "${decompressed}"
David Srbecky69315e42021-04-29 21:06:47 +0100112 else
113 cp -f "${infile}" "${outfile}.tmp"
114 fi
115}
116
117do_strip_keep_mini_debug_info() {
118 case $(uname) in
119 Linux)
120 do_strip_keep_mini_debug_info_linux
121 ;;
122 Darwin)
123 do_strip_keep_mini_debug_info_darwin
124 ;;
125 *) echo "unknown OS:" $(uname) >&2 && exit 1;;
126 esac
127}
128
Colin Cross665dce92016-04-28 14:50:03 -0700129do_add_gnu_debuglink() {
Yi Kongab5e5142019-09-12 21:24:12 -0700130 "${CLANG_BIN}/llvm-objcopy" --add-gnu-debuglink="${infile}" "${outfile}.tmp"
Colin Cross665dce92016-04-28 14:50:03 -0700131}
132
Vic Yangefd249e2018-11-12 20:19:56 -0800133do_remove_build_id() {
Yi Kongab5e5142019-09-12 21:24:12 -0700134 "${CLANG_BIN}/llvm-strip" --remove-section=.note.gnu.build-id "${outfile}.tmp" -o "${outfile}.tmp.no-build-id"
Vic Yangefd249e2018-11-12 20:19:56 -0800135 rm -f "${outfile}.tmp"
136 mv "${outfile}.tmp.no-build-id" "${outfile}.tmp"
137}
138
Colin Cross665dce92016-04-28 14:50:03 -0700139while getopts $OPTSTRING opt; do
140 case "$opt" in
Yi Kongacee27c2019-03-29 20:05:14 -0700141 d) depsfile="${OPTARG}" ;;
142 i) infile="${OPTARG}" ;;
143 o) outfile="${OPTARG}" ;;
144 k) symbols_to_keep="${OPTARG}" ;;
145 -)
146 case "${OPTARG}" in
147 add-gnu-debuglink) add_gnu_debuglink=true ;;
148 keep-mini-debug-info) keep_mini_debug_info=true ;;
149 keep-symbols) keep_symbols=true ;;
Christopher Ferrisb43fe7a2019-05-17 16:39:54 -0700150 keep-symbols-and-debug-frame) keep_symbols_and_debug_frame=true ;;
Yi Kongacee27c2019-03-29 20:05:14 -0700151 remove-build-id) remove_build_id=true ;;
Yi Kongacee27c2019-03-29 20:05:14 -0700152 *) echo "Unknown option --${OPTARG}"; usage ;;
153 esac;;
154 ?) usage ;;
155 *) echo "'${opt}' '${OPTARG}'"
Colin Cross665dce92016-04-28 14:50:03 -0700156 esac
157done
158
159if [ -z "${infile}" ]; then
160 echo "-i argument is required"
161 usage
162fi
163
164if [ -z "${outfile}" ]; then
165 echo "-o argument is required"
166 usage
167fi
168
169if [ -z "${depsfile}" ]; then
170 echo "-d argument is required"
171 usage
172fi
173
174if [ ! -z "${keep_symbols}" -a ! -z "${keep_mini_debug_info}" ]; then
175 echo "--keep-symbols and --keep-mini-debug-info cannot be used together"
176 usage
177fi
178
Christopher Ferrisb43fe7a2019-05-17 16:39:54 -0700179if [ ! -z "${keep_symbols}" -a ! -z "${keep_symbols_and_debug_frame}" ]; then
180 echo "--keep-symbols and --keep-symbols-and-debug-frame cannot be used together"
181 usage
182fi
183
184if [ ! -z "${keep_mini_debug_info}" -a ! -z "${keep_symbols_and_debug_frame}" ]; then
185 echo "--keep-symbols-mini-debug-info and --keep-symbols-and-debug-frame cannot be used together"
186 usage
187fi
188
Yi Kongacee27c2019-03-29 20:05:14 -0700189if [ ! -z "${symbols_to_keep}" -a ! -z "${keep_symbols}" ]; then
190 echo "--keep-symbols and -k cannot be used together"
191 usage
192fi
193
Colin Cross665dce92016-04-28 14:50:03 -0700194if [ ! -z "${add_gnu_debuglink}" -a ! -z "${keep_mini_debug_info}" ]; then
195 echo "--add-gnu-debuglink cannot be used with --keep-mini-debug-info"
196 usage
197fi
198
199rm -f "${outfile}.tmp"
200
201if [ ! -z "${keep_symbols}" ]; then
202 do_strip_keep_symbols
Yi Kongacee27c2019-03-29 20:05:14 -0700203elif [ ! -z "${symbols_to_keep}" ]; then
204 do_strip_keep_symbol_list
Colin Cross665dce92016-04-28 14:50:03 -0700205elif [ ! -z "${keep_mini_debug_info}" ]; then
206 do_strip_keep_mini_debug_info
Christopher Ferrisb43fe7a2019-05-17 16:39:54 -0700207elif [ ! -z "${keep_symbols_and_debug_frame}" ]; then
208 do_strip_keep_symbols_and_debug_frame
Colin Cross665dce92016-04-28 14:50:03 -0700209else
210 do_strip
211fi
212
213if [ ! -z "${add_gnu_debuglink}" ]; then
214 do_add_gnu_debuglink
215fi
216
Vic Yangefd249e2018-11-12 20:19:56 -0800217if [ ! -z "${remove_build_id}" ]; then
218 do_remove_build_id
219fi
220
Colin Cross665dce92016-04-28 14:50:03 -0700221rm -f "${outfile}"
222mv "${outfile}.tmp" "${outfile}"
223
224cat <<EOF > "${depsfile}"
225${outfile}: \
226 ${infile} \
Yi Kongeb63f762019-09-14 01:39:53 -0700227 ${CLANG_BIN}/llvm-nm \
228 ${CLANG_BIN}/llvm-objcopy \
229 ${CLANG_BIN}/llvm-readelf \
230 ${CLANG_BIN}/llvm-strip
Colin Cross665dce92016-04-28 14:50:03 -0700231
232EOF